<?php

namespace Teknisa\Model\Teknisa\Repositories;

class OmProdutoColetor extends \Doctrine\ORM\EntityRepository {    

    public function getProductCollector($productId, $filter = '') {
        $query = <<<SQL
        SELECT *
          FROM (SELECT OPD.ID, OPD.NRPRODUTO_ID, OPD.IDCOLETOR, OPD.IDUTWALLET, OPD.IDATIVO,
                       OPD.DSSTRINGCONEXAO, OPD.DSUSUARIOBANCO, OPD.DSSENHABANCO, 
                       OPI.NMOPERADOR AS NMOPERINCLUSAO, OPU.NMOPERADOR AS NMOPERULTATU,
                       TO_CHAR(OPD.DTINCLUSAO, 'DD/MM/YYYY HH24:MI:SS') AS DTINCLUSAO,
                       TO_CHAR(OPD.DTULTATU, 'DD/MM/YYYY HH24:MI:SS') AS DTULTATU,
                       OPD.IDTPBANCO, CASE WHEN OPD.IDTPBANCO = 'ORACLE'
                                           THEN 'Oracle'
                                           WHEN OPD.IDTPBANCO = 'SQL_SERVER_2000'
                                           THEN 'SQL Server 2000' 
                                           WHEN OPD.IDTPBANCO = 'SQL_SERVER_2005'
                                           THEN 'SQL Server 2005' 
                                           WHEN OPD.IDTPBANCO = 'SQL_SERVER_2009'
                                           THEN 'SQL Server 2009'
                                           ELSE 'MySQL'
                                       END AS NMTPBANCO
                  FROM OM_PRODUTO_COLETOR OPD
             LEFT JOIN OPERADOR OPI ON OPI.CDOPERADOR = OPD.CDOPERINCLUSAO
             LEFT JOIN OPERADOR OPU ON OPU.CDOPERADOR = OPD.CDOPERULTATU
                 WHERE NRPRODUTO_ID = :NRPRODUTO_ID)
         WHERE 1 = 1
               $filter
SQL;

        $params = array (
            'NRPRODUTO_ID' => $productId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}
